package com.onarandombox.MultiverseCore.commands;

import java.util.ArrayList;
import java.util.List;

import org.bukkit.ChatColor;
import org.bukkit.command.CommandSender;
import org.bukkit.entity.Player;
import org.bukkit.permissions.PermissionDefault;

import com.onarandombox.MultiverseCore.MVWorld;
import com.onarandombox.MultiverseCore.MultiverseCore;

public class WhoCommand extends MultiverseCommand {

    public WhoCommand(MultiverseCore plugin) {
        super(plugin);
        this.setName("Who?");
        this.setCommandUsage("/mv who" + ChatColor.GOLD + " [WORLD]");
        this.setArgRange(0, 1);
        this.addKey("mv who");
        this.addKey("mvw");
        this.addKey("mvwho");
        this.setPermission("multiverse.core.list.who", "States who is in what world.", PermissionDefault.OP);
    }

    @Override
    public void runCommand(CommandSender sender, List<String> args) {
        // If this command was sent from a Player then we need to check Permissions
        Player p = null;
        // By default, show all from the console
        boolean showAll = true;
        if (sender instanceof Player) {
            p = (Player) sender;
            showAll = false;
        }

        List<MVWorld> worlds = new ArrayList<MVWorld>();

        if (args.size() > 0) {
            if (args.get(0).equalsIgnoreCase("--all") || args.get(0).equalsIgnoreCase("-a")) {
                showAll = true;
                worlds = new ArrayList<MVWorld>(this.plugin.getMVWorlds());
            } else if (this.plugin.isMVWorld(args.get(0))) {
                worlds.add(this.plugin.getMVWorld(args.get(0)));
            } else {
                sender.sendMessage(ChatColor.RED + "World does not exist");
                return;
            }
        } else {
            worlds = new ArrayList<MVWorld>(this.plugin.getMVWorlds());
        }

        if (worlds.size() == 0) {
            sender.sendMessage("Multiverse does not know about any of your worlds :(");
        } else if (worlds.size() == 1) {
            sender.sendMessage(ChatColor.AQUA + "--- " + "Players in" + ChatColor.YELLOW + worlds.get(0) + ChatColor.AQUA + " ---");
        } else {
            sender.sendMessage(ChatColor.AQUA + "--- There are players in ---");
        }

        for (MVWorld world : worlds) {
            if (!(this.plugin.isMVWorld(world.getName()))) {
                continue;
            }

            if (p != null && (!this.plugin.getPermissions().canEnterWorld(p, world))) {
                continue;
            }
            List<Player> players = world.getCBWorld().getPlayers();

            String result = "";
            if (players.size() <= 0 && !showAll) {
                continue;
            }

            if (players.size() <= 0) {
                result = "Empty";
            } else {
                for (Player player : players) {
                    result += player.getName() + " ";
                }
            }

            sender.sendMessage(world.getColoredWorldString() + ChatColor.WHITE + " - " + result);
        }
    }
}
